--
-- Elektronika dla Wszystkich
-- Szkoa Konstruktorw, zadanie 244 (EdW 06/2016)
-- ESP8266 IoT: WiFi Power Socket / Gniazdko sterowane przez WiFi
-- Copyright (c) 2016 by Marcin 'Malcom' Malich
-- Released under the MIT license
--

Pins = {
	Button		= 5,	-- GPIO14

	RelayOn		= 2,	-- GPIO04
	RelayOff	= 1,	-- GPIO05

	StatusLed	= 6,	-- GPIO12
	WifiLed		= 7,	-- GPIO13
}

dofile('button.lua')
dofile('relay.lua')
dofile('server.lua')
dofile('utils.lua')
dofile('wifi.lua')

local switch = Button(Pins.Button, 0)
local relay = BistableRelay(Pins.RelayOn, Pins.RelayOff)
local led  = Led(Pins.StatusLed)

function main()
	print("Main started...")

	-- connect button action to relay
	switch.Connect(
		function()
			relay.Toggle()
			led.Enable(relay.IsEnabled())
		end
	)

	-- start webserver
	Server.Start(80, 
		function()
			return relay.IsEnabled()
		end,
		function(action)
			relay.Enable(action)
			led.Enable(relay.IsEnabled())
		end
	)

end

-- main code

Wifi.Init(Led(Pins.WifiLed))

if (switch.IsPressed() == true) then
	print("Enable wifi configuration...")
	Wifi.Config(main)

else
	-- normal startup
	main()
end
