--
-- Elektronika dla Wszystkich
-- Szkoa Konstruktorw, zadanie 244 (EdW 06/2016)
-- ESP8266 IoT: WiFi Power Socket / Gniazdko sterowane przez WiFi
-- Copyright (c) 2016 by Marcin 'Malcom' Malich
-- Released under the MIT license
--

function Led(pin)

	-- init
	gpio.mode(pin, gpio.OUTPUT)
	gpio.write(pin, 0)

	return {
		Set = function()
			gpio.write(pin, 1)
		end,
		Reset = function()
			gpio.write(pin, 0)
		end,

		Enable = function(enable)
			gpio.write(pin, enable and 1 or 0)
		end,

		Blink = function(interval)
			if interval == 0 then
				tmr.stop(3)
				gpio.write(pin, 0)
			else
				tmr.alarm(3, interval, 1, function()
					gpio.write(pin, ((gpio.read(pin) ~= gpio.HIGH) and 1 or 0))
					--Enable(gpio.read(pin) ~= gpio.HIGH)
				end)
			end
		end
	}
end
