--
-- Elektronika dla Wszystkich
-- Szkoa Konstruktorw, zadanie 244 (EdW 06/2016)
-- ESP8266 IoT: WiFi Power Socket / Gniazdko sterowane przez WiFi
-- Copyright (c) 2016 by Marcin 'Malcom' Malich
-- Released under the MIT license
--

Wifi = {}

function Wifi.Init(led)
	print("Wifi.Init")

	local function onWifiEvent(status)
	print("Wifi changed status to "..status)
		if status ~= wifi.STA_GOTIP then
			led.Blink(0)
			led.Blink(250)
		else
			led.Blink(0)
			led.Set()
			print("Connected to wifi as " .. wifi.sta.getip())
		end
	end

	wifi.sta.eventMonReg(wifi.STA_IDLE, function() onWifiEvent(wifi.STA_IDLE) end)
	wifi.sta.eventMonReg(wifi.STA_CONNECTING, function() onWifiEvent(wifi.STA_CONNECTING) end)
	wifi.sta.eventMonReg(wifi.STA_WRONGPWD, function() onWifiEvent(wifi.STA_WRONGPWD) end)
	wifi.sta.eventMonReg(wifi.STA_APNOTFOUND, function() onWifiEvent(wifi.STA_APNOTFOUND) end)
	wifi.sta.eventMonReg(wifi.STA_FAIL, function() onWifiEvent(wifi.STA_FAIL) end)
	wifi.sta.eventMonReg(wifi.STA_GOTIP, function() onWifiEvent(wifi.STA_GOTIP) end)

	wifi.sta.eventMonStart()
	onWifiEvent(wifi.sta.status())

	wifi.setmode(wifi.STATION)
	wifi.sta.autoconnect(1)

end

function Wifi.Config(callback)
	print("Wifi.Config")

	wifi.setmode(wifi.STATIONAP)
	wifi.ap.config({ ssid = "ESP8266-Relay-IoT", auth = wifi.OPEN })
	enduser_setup.manual(true)
	enduser_setup.start(
		function()
			print("Enduser setup complete, ssid: " .. wifi.sta.getconfig())
			wifi.setmode(wifi.STATION)
			wifi.sta.autoconnect(1)
			enduser_setup.stop()
			callback()
		end,
		function(err, str)
			print("Enduser setup error: " .. err .. ": " .. str)
		end
	)

end
